/**
 * Given an integer array with no duplicates. A maximum tree building on this array is defined as follow:
 *
 * The root is the maximum number in the array.
 * The left subtree is the maximum tree constructed from left part subarray divided by the maximum number.
 * The right subtree is the maximum tree constructed from right part subarray divided by the maximum number.
 * Construct the maximum tree by the given array and output the root node of this tree.
 *
 * Example 1:
 * Input: [3,2,1,6,0,5]
 * Output: return the tree root node representing the following tree:
 *
 *       6
 *     /   \
 *    3     5
 *     \    /
 *      2  0
 *        \
 *         1
 *
 * Note:
 * The size of the given array will be in the range [1,1000].
 */

import TreeNode from 'common/tree-node';

/**
 * @param {number[]} nums
 * @return {TreeNode}
 */
const constructMaximumBinaryTree = nums => {
  const helper = (i, j) => {
    if (i > j) {
      return null;
    }

    if (i === j) {
      return new TreeNode(nums[i]);
    }

    const k = nums.indexOf(Math.max(...nums.slice(i, j + 1)));
    const root = new TreeNode(nums[k]);

    root.left = helper(i, k - 1);
    root.right = helper(k + 1, j);

    return root;
  };

  return helper(0, nums.length - 1);
};

export default constructMaximumBinaryTree;
